unit Util_Curseur;

{------------------------------------------------------------------------------}
                                   INTERFACE
{------------------------------------------------------------------------------}

uses Controls, Forms, IdGlobal;

procedure StartWait;
procedure StopWait;

type
  TNotifyStopWaitEvent = procedure (Const TempsEcoule : cardinal) of object;

var
  WaitCount   : Integer = 0;
  SaveCursor  : TCursor = crDefault;
  WaitCursor  : TCursor = crHourGlass;
  TempsEcoule : cardinal = 0;
  TempsDebut  : cardinal = 0;
  OnStopWait  : TNotifyStopWaitEvent = nil;

{------------------------------------------------------------------------------}
                                 IMPLEMENTATION
{------------------------------------------------------------------------------}


{----------------------------------START-WAIT----------------------------------}
procedure StartWait;
begin
  if WaitCount = 0 then
  begin
    TempsDebut := GetTickCount;
    SaveCursor := Screen.Cursor;
    Screen.Cursor := WaitCursor;
  end;
  Inc(WaitCount);
end;
{----------------------------------STOP-WAIT-----------------------------------}
procedure StopWait;
begin
  if WaitCount > 0 then
  begin
    Dec(WaitCount);
    if WaitCount = 0 then
    begin
      Screen.Cursor := SaveCursor;
      TempsEcoule := GetTickCount-TempsDebut;
      if Assigned(OnStopWait) then OnStopWait(TempsEcoule);
    end;
  end;
end;
end.
 